//+------------------------------------------------------------------+
//|                                                       %r nrp.mq4 |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers    4
#property indicator_color1     Goldenrod
#property indicator_color2     MidnightBlue
#property indicator_color3     Red
#property indicator_color4     Orange
#property indicator_width2     1
#property indicator_width3     1
#property indicator_minimum    -100
#property indicator_maximum    0
#property indicator_levelcolor SteelBlue
#property indicator_levelstyle 2

//
//
//
//
//

extern int            WprPeriod       = 14;
extern int            T3Period        = 10;
extern double         T3Hot           = 0.7;
extern bool           T3Original      = false;
extern int            MaPeriod        = 4;
extern ENUM_MA_METHOD MaMode          = MODE_SMA;
extern double         levelOb         = -25;
extern double         levelOs         = -85;
extern bool           alertsOn        = true;
extern bool           alertsOnCurrent = false;
extern bool           alertsMessage   = true;
extern bool           alertsSound     = true;
extern bool           alertsNotify    = false;
extern bool           alertsEmail     = false;
extern string         soundFile       = "alert2.wav";

//
//
//
//
//

double wpr[];
double wprma[];
double Up[];
double Dn[];
double slope[];

//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,Up);  SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,159); 
   SetIndexBuffer(1,Dn);  SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,159);
   SetIndexBuffer(2,wprma);
   SetIndexBuffer(3,wpr);
   SetIndexBuffer(4,slope); 
   SetLevelValue(0,levelOs);
   SetLevelValue(1,levelOb);
   IndicatorShortName("%R ("+WprPeriod+")");
return(0);
}

int deinit() {   return(0); }
  
//+------------------------------------------------------------------+
//| Williams? Percent Range                                          |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
    
   for (int i=limit; i>=0; i--)
   { 
       double hi   = High[iHighest(NULL,0,MODE_HIGH,WprPeriod,i)];
       double lo   =  Low[iLowest(NULL, 0,MODE_LOW, WprPeriod,i)];
       if (hi!=lo)      
            wpr[i] = iT3(-100*(hi - Close[i]) / (hi - lo),T3Period,T3Hot,T3Original,i,0);
       else wpr[i] = iT3(0,                               T3Period,T3Hot,T3Original,i,0);
       
         Up[i]      = EMPTY_VALUE;
         Dn[i]      = EMPTY_VALUE;
         slope[i]   = slope[i+1];
         if (wpr[i]>wpr[i+1]) slope[i] = 1;
         if (wpr[i]<wpr[i+1]) slope[i] =-1;
         if (slope[i]== 1) Up[i] = wpr[i];
         if (slope[i]==-1) Dn[i] = wpr[i];  
      }
      for( i=limit; i>=0; i--) wprma[i] = iMAOnArray(wpr,0,MaPeriod,0,MaMode,i);
      
      //
      //
      //
      //
      //
      
      if (alertsOn)
      {
        if (alertsOnCurrent)
             int whichBar = 0;
        else     whichBar = 1;
        if (slope[whichBar] != slope[whichBar+1])
        if (slope[whichBar] == 1)
              doAlert("sloping up");
        else  doAlert("sloping down");       
   }
return(0);
}

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

double workT3[][6];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int forInstance=0)
{
   if (ArrayRange(workT3,0) !=Bars)                  ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (forInstance+1)) ArrayResize(workT3Coeffs,forInstance+1);

   if (workT3Coeffs[forInstance][_period] != period)
   {
     workT3Coeffs[forInstance][_period] = period;
        double a = hot;
            workT3Coeffs[forInstance][_c1] = -a*a*a;
            workT3Coeffs[forInstance][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[forInstance][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[forInstance][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[forInstance][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[forInstance][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = forInstance*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[forInstance][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[forInstance][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[forInstance][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[forInstance][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[forInstance][_c4]*workT3[r][2+buffer]);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];
          
          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," WPR_T3 ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," WPR_T3  "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}

